
/* Subroutine */ int de80d0_c(S_fp f, integer *m, integer *n, doublereal *x,
	doublereal *yx, doublereal *dyx, doublereal *xj0, doublereal *alpn,
	doublereal *cmar, doublereal *ajk, doublereal *au, doublereal *adu,
	doublereal *u, doublereal *du, doublereal *zfi)
{
    /* System generated locals */
    integer cmar_dim1, cmar_offset, ajk_dim1, ajk_offset, au_dim1, au_offset,
	    adu_dim1, adu_offset, u_dim1, u_offset, du_dim1, du_offset,
	    zfi_dim1, zfi_offset, i__1, i__2;

    /* Local variables */
    static integer j, l;
    static doublereal w1;
    extern /* Subroutine */ int de70dq_c(integer *, integer *, doublereal *,
	    doublereal *, doublereal *);

    /* Parameter adjustments */
    zfi_dim1 = *m;
    zfi_offset = 1 + zfi_dim1;
    zfi -= zfi_offset;
    adu_dim1 = *m;
    adu_offset = 1 + adu_dim1;
    adu -= adu_offset;
    au_dim1 = *m;
    au_offset = 1 + au_dim1;
    au -= au_offset;
    ajk_dim1 = *m;
    ajk_offset = 1 + ajk_dim1;
    ajk -= ajk_offset;
    --dyx;
    --yx;
    du_dim1 = *m;
    du_offset = 1 + du_dim1;
    du -= du_offset;
    u_dim1 = *m;
    u_offset = 1 + u_dim1;
    u -= u_offset;
    cmar_dim1 = *n;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;
    --alpn;
    --xj0;

    /* Function Body */
    (*f)(x, &yx[1], &dyx[1], &zfi[zfi_dim1 + 1], m);
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	ajk[l + ajk_dim1] = zfi[l + zfi_dim1] * 2.;
	adu[l + (adu_dim1 << 1)] = com70d_1.hd4 * ajk[l + ajk_dim1];
	adu[l + adu_dim1] = dyx[l] + adu[l + (adu_dim1 << 1)];
	au[l + au_dim1 * 3] = com80d_1.h2d32 * ajk[l + ajk_dim1];
	au[l + (au_dim1 << 1)] = com70d_1.hd2 * (dyx[l] + com70d_1.hd4 * ajk[
		l + ajk_dim1]);
	au[l + au_dim1] = yx[l] + com70d_1.hd2 * dyx[l] + com80d_1.h2d32 * 3.
		* ajk[l + ajk_dim1];
	zfi[l + zfi_dim1] *= com70d_1.wc2;
/* L10: */
    }
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
	w1 = alpn[j] * 2. * alpn[j] - 1.;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
	    du[l + j * du_dim1] = adu[l + adu_dim1] + adu[l + (adu_dim1 << 1)]
		     * alpn[j];
	    u[l + j * u_dim1] = au[l + au_dim1] + au[l + (au_dim1 << 1)] *
		    alpn[j] + au[l + au_dim1 * 3] * w1;
/* L20: */
	}
	(*f)(&xj0[j], &u[j * u_dim1 + 1], &du[j * du_dim1 + 1], &zfi[(j + 1) *
		 zfi_dim1 + 1], m);
/* L30: */
    }
    de70dq_c(m, n, &zfi[zfi_offset], &cmar[cmar_offset], &ajk[ajk_offset]);
    return 0;
} /* de80d0_c */
