
/* Subroutine */ int de80di_c(S_fp f, integer *m, integer *k, integer *iexit,
	doublereal *yx, doublereal *dyx, doublereal *xj0, doublereal *ajk,
	doublereal *hd4i, doublereal *rabc, doublereal *rabc1, doublereal *
	rabc2, doublereal *rabc3, doublereal *alpn, doublereal *cmar,
	doublereal *au, doublereal *adu, doublereal *u, doublereal *du,
	doublereal *zfi)
{
    /* System generated locals */
    integer ajk_dim1, ajk_offset, cmar_dim1, cmar_offset, au_dim1, au_offset,
	    adu_dim1, adu_offset, u_dim1, u_offset, du_dim1, du_offset,
	    zfi_dim1, zfi_offset, i__1, i__2;

    /* Local variables */
    static integer i__, j, l, jl, im1, km1, km2, kp1, kp2, kp3, ip1, ip2, ip3;
    extern /* Subroutine */ int de70dc_(integer *, integer *, doublereal *,
	    doublereal *, doublereal *, doublereal *), de70dq_(integer *,
	    integer *, doublereal *, doublereal *, doublereal *);

    /* Parameter adjustments */
    zfi_dim1 = *m;
    zfi_offset = 1 + zfi_dim1;
    zfi -= zfi_offset;
    adu_dim1 = *m;
    adu_offset = 1 + adu_dim1;
    adu -= adu_offset;
    au_dim1 = *m;
    au_offset = 1 + au_dim1;
    au -= au_offset;
    ajk_dim1 = *m;
    ajk_offset = 1 + ajk_dim1;
    ajk -= ajk_offset;
    --dyx;
    --yx;
    du_dim1 = *m;
    du_offset = 1 + du_dim1;
    du -= du_offset;
    u_dim1 = *m;
    u_offset = 1 + u_dim1;
    u -= u_offset;
    cmar_dim1 = *k;
    cmar_offset = 1 + cmar_dim1;
    cmar -= cmar_offset;
    --alpn;
    --rabc1;
    --rabc;
    --xj0;
    --hd4i;
    --rabc2;
    --rabc3;

    /* Function Body */
    km1 = *k - 1;
    km2 = *k - 2;
    kp1 = *k + 1;
    kp2 = *k + 2;
    kp3 = *k + 3;
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L10: */
	au[l + (au_dim1 << 1)] = 0.f;
    }

/*    CALCULATION SUM SIGMA */

    i__1 = *k;
    for (j = 2; j <= i__1; j += 2) {
	jl = com80d_1.jlas - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L15: */
	    au[l + (au_dim1 << 1)] -= ajk[l + (jl + 1) * ajk_dim1] * rabc[jl];
	}
/* L20: */
    }

    if (*k == 2) {
	goto L32;
    }

/*   THE COLUMN AU(L,3) IS USED AS WORKING ARRAY */

    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L22: */
	au[l + au_dim1 * 3] = 0.f;
    }

    i__1 = *k;
    for (j = 3; j <= i__1; j += 2) {
	jl = com80d_1.jlas1 - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L25: */
	    au[l + au_dim1 * 3] += ajk[l + (jl + 1) * ajk_dim1] * rabc[jl];
	}
/* L30: */
    }

    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L31: */
	au[l + (au_dim1 << 1)] += au[l + au_dim1 * 3];
    }
/* ------------------------------------------------------- */
L32:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	adu[l + adu_dim1] = (dyx[l] + com70d_1.hd4 * (ajk[l + ajk_dim1] - ajk[
		l + (ajk_dim1 << 1)] * .5) + com70d_1.hd2 * au[l + (au_dim1 <<
		 1)]) * 2.;
	adu[l + kp1 * adu_dim1] = hd4i[*k] * ajk[l + *k * ajk_dim1];
	adu[l + kp2 * adu_dim1] = hd4i[kp1] * ajk[l + kp1 * ajk_dim1];
/* L35: */
    }
    i__1 = km1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	ip1 = i__ + 1;
	ip2 = i__ + 2;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L40: */
	    adu[l + ip1 * adu_dim1] = hd4i[i__] * (ajk[l + i__ * ajk_dim1] -
		    ajk[l + ip2 * ajk_dim1]);
	}
/* L45: */
    }

/*    CALCULATION SUM OF LAST TWO TERMS FOR J=K AND J=K-1 */

    if (*k % 2 != 0) {
	goto L60;
    } else {
	goto L50;
    }
L50:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L55: */
	au[l + au_dim1] = rabc1[km1] * ajk[l + *k * ajk_dim1] - rabc1[*k] *
		ajk[l + kp1 * ajk_dim1];
    }
    goto L70;
L60:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L65: */
	au[l + au_dim1] = -rabc1[km1] * ajk[l + *k * ajk_dim1] + rabc1[*k] *
		ajk[l + kp1 * ajk_dim1];
    }
/* ------------------------------------------------------- */
L70:
    if (*k == 2) {
	goto L95;
    }
    if (*k == 3) {
	goto L92;
    }

/*   CALCULATION THE LAST SUM */

    i__1 = km2;
    for (j = 2; j <= i__1; j += 2) {
	jl = com80d_1.jlas2 - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L75: */
	    au[l + au_dim1] -= rabc1[jl] * (ajk[l + (jl + 1) * ajk_dim1] -
		    ajk[l + (jl + 3) * ajk_dim1]);
	}
/* L80: */
    }

/*   CONTINUATION OF CALCULATION THE LAST SUM */

/*   THE COLUMN AU(L,3) IS USED AS WORKING ARRAY */

    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L81: */
	au[l + au_dim1 * 3] = 0.f;
    }
    i__1 = km2;
    for (j = 1; j <= i__1; j += 2) {
	jl = com80d_1.jlas3 - j;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L85: */
	    au[l + au_dim1 * 3] += rabc1[jl] * (ajk[l + (jl + 1) * ajk_dim1]
		    - ajk[l + (jl + 3) * ajk_dim1]);
	}
/* L90: */
    }

    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L91: */
	au[l + au_dim1] += au[l + au_dim1 * 3];
    }
    goto L95;

/*    CASE (EVENT) FOR K=3 */

L92:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
/* L93: */
	au[l + au_dim1] += rabc1[1] * (ajk[l + (ajk_dim1 << 1)] - ajk[l + (
		ajk_dim1 << 2)]);
    }
/* -------------------------------------------------------- */
/* -------------------------------------------------------- */
L95:
    i__1 = *m;
    for (l = 1; l <= i__1; ++l) {
	au[l + au_dim1] = (yx[l] + com70d_1.hd2 * dyx[l] + com80d_1.h2d32 * (
		ajk[l + ajk_dim1] * 3. - ajk[l + (ajk_dim1 << 1)] * 2. + ajk[
		l + ajk_dim1 * 3]) + com80d_1.h2d4 * au[l + (au_dim1 << 1)] -
		com80d_1.h2d8 * au[l + au_dim1]) * 2.;

	if (*k == 2) {
	    goto L96;
	}

	au[l + (au_dim1 << 1)] = com70d_1.hd2 * (dyx[l] + com70d_1.hd4 * (ajk[
		l + ajk_dim1] - ajk[l + (ajk_dim1 << 1)] * .75 + ajk[l + (
		ajk_dim1 << 2)] * .25) + com70d_1.hd2 * au[l + (au_dim1 << 1)]
		);
	goto L97;

L96:
	au[l + (au_dim1 << 1)] = com70d_1.hd2 * (dyx[l] + com70d_1.hd4 * (ajk[
		l + ajk_dim1] - ajk[l + (ajk_dim1 << 1)] * .75) +
		com70d_1.hd2 * au[l + (au_dim1 << 1)]);
	goto L99;

L97:
	if (*k == 3) {
	    goto L98;
	}

	au[l + au_dim1 * 3] = com80d_1.h2d96 * (ajk[l + ajk_dim1] * 3. - ajk[
		l + ajk_dim1 * 3] * 4. + ajk[l + ajk_dim1 * 5]);
L98:
	au[l + *k * au_dim1] = com80d_1.h2d16 * (rabc2[km1] * ajk[l + km2 *
		ajk_dim1] - rabc3[km1] * ajk[l + *k * ajk_dim1]);
L99:
	au[l + kp1 * au_dim1] = com80d_1.h2d16 * (rabc2[*k] * ajk[l + km1 *
		ajk_dim1] - rabc3[*k] * ajk[l + kp1 * ajk_dim1]);
	au[l + kp2 * au_dim1] = com80d_1.h2d16 * rabc2[kp1] * ajk[l + *k *
		ajk_dim1];
	au[l + kp3 * au_dim1] = com80d_1.h2d16 * rabc2[kp2] * ajk[l + kp1 *
		ajk_dim1];
/* L100: */
    }

    if (*k < 5) {
	goto L116;
    }
    i__1 = km2;
    for (i__ = 3; i__ <= i__1; ++i__) {
	im1 = i__ - 1;
	ip1 = i__ + 1;
	ip3 = i__ + 3;
	i__2 = *m;
	for (l = 1; l <= i__2; ++l) {
/* L110: */
	    au[l + ip1 * au_dim1] = com80d_1.h2d16 * (rabc2[i__] * ajk[l +
		    im1 * ajk_dim1] - rabc3[i__] * ajk[l + ip1 * ajk_dim1] +
		    rabc2[ip1] * ajk[l + ip3 * ajk_dim1]);
	}
/* L115: */
    }

L116:
    if (*iexit == 1) {
	goto L130;
    }
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	de70dc_c(m, &kp1, &alpn[j], &adu[adu_offset], &du[j * du_dim1 + 1], &
		zfi[kp2 * zfi_dim1 + 1]);
	de70dc_c(m, &kp2, &alpn[j], &au[au_offset], &u[j * u_dim1 + 1], &zfi[
		kp2 * zfi_dim1 + 1]);
/* L120: */
    }
    if (*iexit == 2) {
	goto L130;
    }
    i__1 = *k;
    for (j = 1; j <= i__1; ++j) {
	(*f)(&xj0[j], &u[j * u_dim1 + 1], &du[j * du_dim1 + 1], &zfi[(j + 1) *
		 zfi_dim1 + 1], m);
/* L125: */
    }
    if (*iexit == 3) {
	goto L130;
    }
    de70dq_c(m, k, &zfi[zfi_offset], &cmar[cmar_offset], &ajk[ajk_offset]);
L130:
    return 0;
} /* de80di_c */
